<?php
class SpecialCognitiveProcessDesignerTestSuite extends SpecialPage {
    function __construct() {
        parent::__construct( 'CognitiveProcessDesignerTestSuite' );
    }
    
    function getGroupName() {
        return 'semantic-process';
    }
    
    function execute( $par ) {
        global $wgOut;
        global $wgScriptPath;
        $request = $this->getRequest();
     //   $wgOut->addModules( 'ext.myExtension' );
        $this->setHeaders();
        $html = "
<!DOCTYPE html>
<html>
<head>
  <title>Cognitive Process Designer Test Suite</title>
  
  <meta charset='utf-8'>
  <meta http-equiv='content-type' content='text/html; charset=utf-8'>
  <meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
  <meta name='author' content='Tobias Weller'>

  <link rel='stylesheet' href='" . $wgScriptPath . "/extensions/CognitiveProcessDesigner/includes/modeler/css/diagram-js.css' />
  <link rel='stylesheet' href='" . $wgScriptPath . "/extensions/CognitiveProcessDesigner/includes/modeler/css/app.css' />
  <link rel='stylesheet' href='" . $wgScriptPath . "/extensions/CognitiveProcessDesigner/includes/modeler/img/favicon.ico' />

</head>
<body class='intro'>
  <div class='content' id='js-drop-zone' style='height: 800px'>


    <div class='screen loading'>

      <div class='note'>
        <div class='project-logo'>
          <span class='icon-bpmn-io'></span>
        </div>

        <div class='message'>
          loading diagram, please hang tight
          <span class='icon-loading animate-spin'></span>
        </div>
      </div>
    </div>

    <div class='screen error'>
      <div class='note'>
        <div class='message'>
          <p>
            Ooops, we could not display the diagram.
          </p>
          <p>
            <small>
              You believe your input is valid <a href='http://www.omg.org/spec/BPMN/2.0/'>BPMN 2.0 XML</a>?
              Consult our <a href='https://forum.bpmn.io' target='_blank'>forum</a> or
              <a href='https://github.com/bpmn-io/bpmn-js/issues' target='_blank'>file an issue</a> in our <a href='https://github.com/bpmn-io/bpmn-js/issues' target='_blank'>issue tracker</a>.
            </small>
          </p>
        </div>

        <div class='details'>
          <span>Some details on the problem</span>
          <textarea class='error-log'></textarea>
        </div>
      </div>
    </div>

    <div class='canvas' id='js-canvas'></div>
  </div>

  <div id='importExport' class='io-import-export'>

    <ul class='io-import io-control io-control-list io-horizontal'>
      <li>
        <button title='open BPMN diagram from local file system' jsaction='click:bio.openLocal'>
          <span class='icon-open'></span>
        </button>
      </li>
      <li class='vr' style='margin-left: 2px'></li>
      <li>
        <button title='create new BPMN diagram' jsaction='click:bio.createNew'>
          <span class='icon-plus-circled'></span>
        </button>
      </li>
    </ul>

    <!--[if !IE]><!-->
    <ul class='io-export io-control io-control-list io-horizontal'>
      <li>
        <a target='_blank' href class='download' title='download BPMN diagram' jswidget='downloadBPMN' data-track='diagram:download-bpmn'>
          <span class='icon-download'></span>
        </a>
      </li>
      <li>
        <a target='_blank' href class='download' title='download as SVG image' jswidget='downloadSVG' data-track='diagram:download-svg'>
          <span class='icon-picture'></span>
        </a>
      </li>
    </ul>
    <!--<![endif]-->
  </div>

  <div class='io-alerts'>

    <div class='io-control alert' jswidget='import-warnings-alert'>
      <a href class='close' aria-hidden='true' jsaction='click:bio.clearImportDetails'>&times;</a>
      Diagram may not render correctly due to import warnings.

      <a href jsaction='click:bio.showImportDetails'>Show details</a>.
    </div>

    <div class='io-control alert' jswidget='undo-redo-alert'>
      You edited the diagram.

      <a href jsaction='click:bio.undo'>Undo last change</a>.

      <a href class='close' aria-hidden='true' jsaction='click:bio.hideUndoAlert'>&times;</a>
    </div>

  </div>




  <div id='infoBox' class='io-editing-tools' jswidget='editing-tools'>
    <ul class='io-control-list io-horizontal'>
      <li class='io-control'>
        <button title='Toggle keyboard shortcuts overlay'
                jsaction='click:bio.showKeyboard'>
          <span class='icon-keyboard'> </span>
        </button>
      </li>
      <li class='io-control'>
        <button title='Toggle Fullscreen'
                jsaction='click:bio.toggleFullscreen'>
          <span class='icon-resize-full'> </span>
        </button>
      </li>
    </ul>
  </div>

  <div class='io-zoom-controls'>

    <ul class='io-zoom-reset io-control io-control-list'>
      <li>
        <button title='reset zoom' jsaction='click:bio.zoomReset'>
          <span class='icon-size-reset'></span>
        </button>
      </li>
    </ul>

    <ul class='io-zoom io-control io-control-list'>
      <li>
        <button title='zoom in' jsaction='click:bio.zoomIn'>
          <span class='icon-plus'></span>
        </button>
      </li>
      <li>
        <hr/>
      </li>
      <li>
        <button href title='zoom out' jsaction='click:bio.zoomOut'>
          <span class='icon-minus'></span>
        </button>
      </li>
    </ul>
  </div>


  <div class='io-dialog about' jswidget='about-dialog'>

    <div class='content'>
      <h1>About bpmn.io</h1>

      <p>
        bpmn.io offers tools to view, annotate and edit <a href='http://www.bpmn.org'>BPMN 2.0</a> diagrams on the web.
        Refer to our <a href='http://bpmn.io'>project website</a> for more information.
      </p>

      <p>
        This is a demo of <a href='https://github.com/bpmn-io/bpmn-js'>bpmn-js</a> the JavaScript toolkit that powers bpmn.io.
      <p>

      <h2>Built with open-source software</h2>

      <p>
        <a href='https://github.com/bpmn-io/bpmn-js'>bpmn-js</a> is built with the help of a number of open-source libraries:
      </p>

      <ul>
        <li><a href='https://github.com/isaacs/sax-js'>saxjs</a></li>
        <li><a href='http://snapsvg.io'>snapsvg</a></li>
        <li><a href='http://jquery.com'>jquery</a></li>
      </ul>

      <p>
        Icons are assembled using <a href='http://fontello.com'>fontello</a> from the following icon fonts:
      </p>

      <ul>
        <li><a href='http://fontello.com'>Fontelico</a> crowdsourced, for Fontello project</li>
        <li><a href='http://fortawesome.github.com/Font-Awesome/'>Font Awesome</a> by Dave Gandy</li>
        <li><a href='http://www.entypo.com'>Entypo</a> by Daniel Bruce</li>
        <li><a href='http://somerandomdude.com/work/iconic/'>Iconic</a> by P.J. Onori</li>
      </ul>

      <a class='project-logo' href='http://bpmn.io'>
        <span class='icon-bpmn-io'></span>
      </a>

      <p>
        You can find all bpmn.io related open-source projects on
        <a href='https://github.com/bpmn-io'>GitHub</a>.
      </p>
    </div>
  </div>

  <div class='io-dialog import-warnings' jswidget='import-warnings-dialog'>

    <div class='content'>
      <h1>Import Warnings</h1>

      <p>
        One or more problems have been identified when trying to import the BPMN 2.0 diagram:
      </p>

      <p>
        <textarea class='error-log'></textarea>
      <p>

      <p>
        This may have been caused by malformed input data.
        As a result the diagram may not render correctly.
      </p>

      <h2>Need help on this?</h2>

      <p>
        File a report in <a href='https://forum.bpmn.io' target='_blank'>our forum</a>.
        Attach your diagram and the above error log.
      </p>

      <a class='project-logo' href='http://bpmn.io'>
        <span class='icon-bpmn-io'></span>
      </a>
    </div>
  </div>

  <div class='io-dialog keybindings-dialog' jswidget='keybindings-dialog'>

    <div class='content bindings-mac'>
      <h1>Keyboard Shortcuts</h1>
      <table>
        <tbody>
          <tr>
            <td>Undo</td>
            <td class='binding'>⌘ + Z</td>
          </tr>
          <tr>
            <td>Redo</td>
            <td class='binding'>⌘ + ⇧ + Z</td>
          </tr>
          <tr>
            <td>Select All</td>
            <td class='binding'>⌘ + A</td>
          </tr>
          <tr>
            <td>Scrolling (Vertical)</td>
            <td class='binding'>⌥ + Scrolling</td>
          </tr>
          <tr>
            <td>Scrolling (Horizontal)</td>
            <td class='binding'>⌥ + ⇧ + Scrolling</td>
          </tr>
          <tr>
            <td>Direct Editing</td>
            <td class='binding'>E</td>
          </tr>
          <tr>
            <td>Lasso Tool</td>
            <td class='binding'>L</td>
          </tr>
          <tr>
            <td>Space Tool</td>
            <td class='binding'>S</td>
          </tr>
        </tbody>
      </table>
    </div>

    <div class='content bindings-default'>
      <h1>Keyboard Shortcuts</h1>
      <table>
        <tbody>
          <tr>
            <td>Undo</td>
            <td class='binding'><code>ctrl + Z</td>
          </tr>
          <tr>
            <td>Redo</td>
            <td class='binding'><code>ctrl + ⇧ + Z</td>
          </tr>
          <tr>
            <td>Select All</td>
            <td class='binding'><code>ctrl + A</td>
          </tr>
          <tr>
            <td>Scrolling (Vertical)</td>
            <td class='binding'>ctrl + Scrolling</td>
          </tr>
          <tr>
            <td>Scrolling (Horizontal)</td>
            <td class='binding'>ctrl + ⇧ + Scrolling</td>
          </tr>
          <tr>
            <td>Direct Editing</td>
            <td class='binding'>E</td>
          </tr>
          <tr>
            <td>Lasso Tool</td>
            <td class='binding'>L</td>
          </tr>
          <tr>
            <td>Space Tool</td>
            <td class='binding'>S</td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>

  <!-- App JavaScript -->
  <script src='". $wgScriptPath ."/extensions/CognitiveProcessDesigner/includes/modeler/lib/appTestSuite.js'></script>

  </body>
</html>
";


        
        
        $wgOut->addHTML($html);
    }

}